#!/usr/bin/ksh93
#############################################################
# Program:	chAdminUserPasswd.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.3	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

####  POST form: read from standard input
read -r -- QUERY_STRING

parseVars
initializeDoc
displayHeader
defineLocations
linkbar CURRENTDIR DDDIR
defineStructInfo
INFODES[3]="New Authorization Structure for Administrator:"
INFOVAL[3]="${DDDIR}"
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

Creating a new directory administrator authorization structure in the
current working directory.

</FONT></P>
<P><HR></P>"

################################################################
####	First check the password protection parameters
################################################################

chkvalue "${ADM_USERID}"	"Directory Administrator ID"
chkvalue "${ADM_PASSWORD}"	"Directory Administrator Password"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"

ADMTMPFILE="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}chAdminUserPasswd${$}.tmp"
rm -f "${ADMTMPFILE}"
/usr/sbin/htpasswd2 -b -s -c "${ADMTMPFILE}" "${ADM_USERID}" "${ADM_PASSWORD}" >/dev/null 2>&1

  if [[ -f "${ADMTMPFILE}" ]]
  then
    chmod 600 "${ADMTMPFILE}"
    if grep "^${ADM_USERID}:" "${ADMPWDFILE}" | head -1 | diff "${ADMTMPFILE}" - > /dev/null 2>&1
    then
      print -- "<BR>Directory Administrator <I>${ADM_USERID}</I> Verified.<BR>"
      EXITLEVEL="0"
    else
      print -- "<BR><STRONG>ERROR:</STRONG> Improper Directory Administrator ID or password.<BR>"
    fi
    rm -f "${ADMTMPFILE}"
  else
    print -- "<BR><STRONG>ERROR:</STRONG> Unable to compare Directory Administrator login.<BR>"
  fi

################################################################

if (( ${EXITLEVEL} == 0 ))
then
    USRPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
    USRPWDFILE="${USRPWDDIR}.diradmin"
    cp -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}.AID_admin" "${USRPWDFILE}" > /dev/null 2>&1
    cp -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}.AID_admin" "${USRPWDDIR}" > /dev/null 2>&1
    touch "${USRPWDFILE}" > /dev/null 2>&1
    chmod 600 "${USRPWDFILE}" > /dev/null 2>&1
  
    print -- "<P><STRONG>"
    print -- "New Directory Administrator Authorization Structure has been created.<BR>"
    print -- "</STRONG></P>"
fi
  

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
