#!/usr/bin/ksh93
#############################################################
# Program:	rmAdmin.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.3	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

####  POST form: read from standard input
read -r -- QUERY_STRING

parseVars
initializeDoc
displayHeader
defineLocations
linkbar CURRENTDIR DDDIR
defineStructInfo
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

Remove one or more administrator's from the current directory
administrator authorization structure.

</FONT></P>
<P><HR></P>"

################################################################
####	First check the password protection parameters
################################################################

chkvalue "${ADM_USERID}"	"Directory Administrator ID"
chkvalue "${ADM_PASSWORD}"	"Directory Administrator Password"
chkvalue "${USERID}"		"User ID"

################################################################
####	compare passwords
################################################################
EXITLEVEL="1"

ADMTMPFILE="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}rmAdmin${$}.tmp"
rm -f "${ADMTMPFILE}"
/usr/sbin/htpasswd2 -b -s -c "${ADMTMPFILE}" "${ADM_USERID}" "${ADM_PASSWORD}" >/dev/null 2>&1

# print -- "ADMPWDFILE=${ADMPWDFILE}<BR>"
# print -- "ADMTMPFILE=${ADMTMPFILE}<BR>"
# print -- "HTPWDFILE=${HTPWDFILE}<BR>"

  if [[ -f "${ADMTMPFILE}" ]]
  then
    chmod 600 "${ADMTMPFILE}"
    if grep "^${ADM_USERID}:" "${ADMPWDFILE}" | head -1 | diff "${ADMTMPFILE}" - > /dev/null 2>&1
    then
      print -- "<BR>Directory Administrator <I>${ADM_USERID}</I> Verified.<BR>"
      EXITLEVEL="0"
    else
      print -- "<BR><STRONG>ERROR:</STRONG> Improper Directory Administrator ID or password.<BR>"
    fi
    rm -f "${ADMTMPFILE}"
  else
    print -- "<BR><STRONG>ERROR:</STRONG> Unable to compare Directory Administrator login.<BR>"
  fi

################################################################

if (( ${EXITLEVEL} == 0 ))
then
  if [[ "_${NEW_PASSWORD}" == "_${NEW_RETYPEPW}" ]]
  then
    if [[ -f "${ADMPWDFILE}" ]]
    then
      touch "${ADMPWDFILE}" 2>&1
      chmod 600 "${ADMPWDFILE}" 2>&1
      IFS=$' \t\n,:;|'
      for U in "${PARSED[@]}"
      do
        if [[ "_${U}" == _USERID=* ]]
        then
          U="${U##*=}"
          if [[ "_${U}" == "_admin" ]] || [[ "_${U}" == "_${ADM_USERID}" ]]
          then
              print -- "ERROR: Removing \"${U}\" is not allowed.<BR>"
          else
              print -- "Removing Directory Administrator \"${U}\"<BR>"
              /usr/sbin/htpasswd2 -D "${ADMPWDFILE}" "${U}" 2>&1 |
                  sed -e "s/^User/Administrator/g"
              print -- "<BR>"
              rm -f "${ADMPWDDIR}.AID_${U}"
              if [[ -f "${ADMPWDDIR}.AID_${U}" ]]
              then
                  rm -f "${ADMPWDDIR}.AID_${U}"
              else
                  print -- "Administrator file \"${U}\" not found.<BR>"
              fi
          fi
        fi
      done
      IFS=$' \t\n'
    fi
  else
    print -- "<P><STRONG>ERROR: Passwords do not match. Go back and try again.</STRONG></P>"
  fi
fi
  
################################################################

print -- "<P><FONT Size=\"4\"><STRONG>"
print -- "<A Href=\"${SCRIPT_CGI}/mkAdminForm.cgi?DDDIR=${DDDIR}\">Add another Directory Administrator</A><BR>"
print -- "<A Href=\"${SCRIPT_CGI}/rmAdminForm.cgi?DDDIR=${DDDIR}\">Remove another Directory Administrator</A><BR>"
print -- "</STRONG></FONT></P>"

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
