#!/usr/bin/ksh93
#############################################################
# Program:	rmAdminAuthForm.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.3	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061027
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

parseVars
initializeDoc
displayHeader
defineLocations

################################################################

BASEDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}"
PARPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
PARPWDDIR="${PARPWDDIR%%+(/)}"
PARPWDDIR="${PARPWDDIR%/*}/"
PARPWDFILE=""
AUTHFILE=".diradmin"
findAuthFile BASEDIR PARPWDDIR PARPWDFILE AUTHFILE

################################################################

BASEDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}"
CHIPWDDIR="${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}"
CHIPWDFILE=""
AUTHFILE=".diradmin"
findAuthFile BASEDIR CHIPWDDIR CHIPWDFILE AUTHFILE

################################################################

linkbar CURRENTDIR DDDIR
defineStructInfo

INFODES[3]="Parent Administrator Authorization Structure:"
INFODES[4]="Child Administrator Authorization Structure:"
INFOVAL[3]="/${PARPWDDIR#${DOCUMENT_ROOT}/..${DOCUMENT_BASE}}"
INFOVAL[4]="/${CHIPWDDIR#${DOCUMENT_ROOT}/..${DOCUMENT_BASE}}"

displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

This form provides the \"parent\" directory administrator with the
ability to remove an entire \"child\" directory administrator
authorization structure. 

</FONT></P>
<P><HR></P>"

################################################################

print -- "<FORM Method=\"post\" Action=\"rmAdminAuth.cgi\">"
print -- "<INPUT Type=\"hidden\" Name=\"DDDIR\" Value=\"${DDDIR}\">"

print -- "
<P>
<TABLE Border=\"0\">
<P>
  <CAPTION>
    <FONT Size=\"+2\"><STRONG>
Remove a Directory Administrator Authorization Structure
<BR>&nbsp;
    </STRONG></FONT>
  </CAPTION>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator ID:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>"

################################################################

print -- "<SELECT Name=\"ADM_USERID\">"
print -- "<OPTION Value=\"NULL\" Selected>Select an ID</OPTION>"
IFS=$'\n'
for ADMID in $( awk -F: '{ print $1 }' < "${PARPWDFILE}" )
do
  print -- "<OPTION Value=\"${ADMID}\">${ADMID}</OPTION>"
done
IFS=$' \t\n'
print -- "</SELECT>"

################################################################

print -- "      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>

Enter the "parent" Administrator's ID.  The Administrator's ID can be up
to 8 characters and must contain only letters, numbers or spaces.

      </I></FONT>

<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
Administrator<BR>Password:
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"password\" Name=\"ADM_PASSWORD\" Size=\"8\" Maxlength=\"8\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>

Enter the "parent" Administrator's current password.  The user password
can be up to 8 characters and must  contain only letters, numbers or
spaces.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
<P>
  <TR>
    <TD Align=\"right\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
&nbsp;
      </STRONG></FONT>
    </TD>
    <TD Align=\"left\" Valign=\"top\">
      <FONT Size=\"+1\"><STRONG>
<INPUT Type=\"submit\" Value=\"Submit\">
      </STRONG></FONT>
<BR>
      <FONT Size=\"-1\"><I>

Create a new directory administrator authorization structure beginning at 
the current working directory.

      </I></FONT>
<HR>
    </TD>
  </TR>
</P>
</TABLE>
</P>
</FORM>
"

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0
