#!/usr/bin/ksh93
#############################################################
# Program:	utilities.cgi
#               Copyright 2006, All Rights Reserved
#
# Description:	Version 0.3	
#
# Author:	Dana French (dfrench@mtxia.com)
#		615.556.0456
#
# Date:		20061024
#
#############################################################
# DOCUMENT_ROOT comes from the web server shell environment
DOCUMENT_BASE="/kshAuth/"
DOCUMENT_DIR="${DOCUMENT_ROOT}${DOCUMENT_BASE}"
SCRIPT_DIR="${SCRIPT_FILENAME%/*}"
SCRIPT_CGI="${SCRIPT_NAME%/*}"
FPATH="${SCRIPT_DIR}"
SEARCHTERM=""

parseVars
initializeDoc
displayHeader
defineLocations
linkbar CURRENTDIR DDDIR
defineStructInfo
displayStructInfo INFODES INFOVAL

################################################################

print -- "<P><FONT Size=\"+1\">

kshAuth utilities for controlling the authorization structure. Permits
adding/removing directory administrators and users, creating/deleting 
authorization levels, and modifying passwords.

</FONT</P>
<P><HR></P>"

################################################################

print -- "<P><H2>User Utilities</H2></P>"
print -- "<P>\n<UL>"

if [[ -f "${AUTHFPFN}" ]]
then
  print -- "<LI> <A Href=\"${SCRIPT_CGI}/chUserPasswdForm.cgi?DDDIR=${URI_DIR}\">Change password</A> - Allows the user to change their own password</LI>"
else
  print -- "<LI> <FONT Color=\"gray\">Change password</FONT> - Allows the user to change their own password - This directory is not password protected</LI>"
fi

print -- "</UL></P>"

################################################################

print -- "<P><HR></P>"
print -- "<P><H2>Directory Administrator Utilities</H2>"
print -- "<UL>"
print -- "<LI> <A Href=\"${SCRIPT_CGI}/chAdminPasswdForm.cgi?DDDIR=${URI_DIR}\">Change Password</A> - Allows the directory administrator to change their own password</LI>"
print -- "<LI> <A Href=\"${SCRIPT_CGI}/chAdminUserPasswdForm.cgi?DDDIR=${URI_DIR}\">Change User Password</A> - Allows the directory administrator to change a user's password</LI>"

################################################################

print -- "</UL></P><P><UL>"

if [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" ]]
then
    print -- "<LI> <FONT Color=\"gray\">Create Admin Authorization Level</FONT> - An authorization level for directory administrators already exists in the current working directory</LI>"
else
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/mkAdminAuthForm.cgi?DDDIR=${DDDIR}\">Create Admin Authorization Level</A> - Create a new authorization level for directory administrators in the current working directory</LI>"
fi

if [[ "_${ADMPWDDIR}" != "_${DOCUMENT_ROOT}/..${DOCUMENT_BASE}" ]] &&
   [[ -f "${DOCUMENT_ROOT}/..${DOCUMENT_BASE}${DDDIR}.diradmin" ]]
then
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/rmAdminAuthForm.cgi?DDDIR=${DDDIR}\">Remove Admin Authorization Level</A> - Remove an existing authorization level for directory administrators from the current working directory</LI>"
else
    print -- "<LI> <FONT Color=\"gray\">Remove Admin Authorization Level</FONT> - An authorization level for directory administrators does not currently exist in the current working directory</LI>"
fi

################################################################

print -- "</UL></P><P><UL>"

print -- "<LI> <A Href=\"${SCRIPT_CGI}/mkAdminForm.cgi?DDDIR=${ADMPWDDIR#${DOCUMENT_ROOT}/..${DOCUMENT_BASE}}\">Add Directory Administrator</A> - Add a directory administrator to the existing authorization structure</LI>"

if [[ -f "${ADMPWDFILE}" ]]
then
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/rmAdminForm.cgi?DDDIR=${ADMPWDDIR#${DOCUMENT_ROOT}/..${DOCUMENT_BASE}}\">Remove Directory Administrator</A> - Remove a directory administrator from the existing authorization structure</LI>"
else
    print -- "<LI> <FONT Color=\"gray\">Remove Directory Administrator</FONT> -  This directory does not have a designated administrator</LI>"
fi

################################################################

print -- "</UL></P><P><UL>"

if [[ -f "${AUTHFPFN}" ]] &&
   grep -i '^ *AuthUserFile' "${HTTPFPFN}" > /dev/null 2>&1
then
    print -- "<LI> <FONT Color=\"gray\">Enable Password Protection</FONT> - The current working directory is already under the control of a directory authorization structure.</LI>"
else
    [[ "_${AUTHFPFN}" == "_" ]] && URI_DIR="${DDDIR}"
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/mkUserAuthForm.cgi?DDDIR=${URI_DIR}\">Enable Password Protection</A> - Configure password protection for the current working directory.</LI>"
fi

if [[ -f "${AUTHFPFN}" ]] &&
   grep -i '^ *AuthUserFile' "${HTTPFPFN}" > /dev/null 2>&1
then
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/rmUserAuthForm.cgi?DDDIR=${URI_DIR}\">Disable Password Protection</A> - Disable password protection for the current authorization structure.</LI>"
else
    print -- "<LI> <FONT Color=\"gray\">Disable Password Protection</FONT> -  Disable password protection for the current working directory - The current working directory is not password protected</LI>"
fi

################################################################

print -- "</UL></P>"

################################################################

print -- "<P><UL>"

if [[ -f "${AUTHFPFN}" ]] &&
   grep -i '^ *AuthUserFile' "${HTTPFPFN}" > /dev/null 2>&1
then
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/mkUserForm.cgi?DDDIR=${URI_DIR}\">Grant Access</A> - Grant a user access to the current authorization structure.</LI>"
else
    print -- "<LI> <FONT Color=\"gray\">Grant Access</FONT> - Grant a user access to the current authorization structure - No users are configured in the current authorization structure</LI>"
fi

if [[ -s "${AUTHFPFN}" ]] &&
   grep -i '^ *AuthUserFile' "${HTTPFPFN}" > /dev/null 2>&1
then
    print -- "<LI> <A Href=\"${SCRIPT_CGI}/rmUserForm.cgi?DDDIR=${URI_DIR}\">Deny Access</A> - Deny a user access to the current authorization structure.</LI>"
else
    print -- "<LI> <FONT Color=\"gray\">Deny Access</FONT> - Deny a user access to the current authorization structure - No users are configured in the current authorization structure</LI>"
fi

print -- "</UL></P>"

################################################################

linkbar CURRENTDIR DDDIR
displayReadme
finalizeDoc

exit 0

